/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
	"fmt"
)

// Currency - struct for Currency
type Currency struct {
	NativeCurrency     *NativeCurrency
	SmartTokenCurrency *SmartTokenCurrency
	TokenCurrency      *TokenCurrency
}

// NativeCurrencyAsCurrency is a convenience function that returns NativeCurrency wrapped in Currency
func NativeCurrencyAsCurrency(v *NativeCurrency) Currency {
	return Currency{NativeCurrency: v}
}

// SmartTokenCurrencyAsCurrency is a convenience function that returns SmartTokenCurrency wrapped in Currency
func SmartTokenCurrencyAsCurrency(v *SmartTokenCurrency) Currency {
	return Currency{SmartTokenCurrency: v}
}

// TokenCurrencyAsCurrency is a convenience function that returns TokenCurrency wrapped in Currency
func TokenCurrencyAsCurrency(v *TokenCurrency) Currency {
	return Currency{TokenCurrency: v}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *Currency) UnmarshalJSON(data []byte) error {
	var err error
	// use discriminator value to speed up the lookup
	var jsonDict map[string]interface{}
	err = json.Unmarshal(data, &jsonDict)
	if err != nil {
		return fmt.Errorf("Failed to unmarshal JSON into map for the discrimintor lookup.")
	}

	// check if the discriminator value is 'native'
	if jsonDict["type"] == "native" {
		// try to unmarshal JSON data into NativeCurrency
		err = json.Unmarshal(data, &dst.NativeCurrency)
		if err == nil {
			return nil // data stored in dst.NativeCurrency, return on the first match
		} else {
			dst.NativeCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as NativeCurrency: %s", err.Error())
		}
	}

	// check if the discriminator value is 'native_currency'
	if jsonDict["type"] == "native_currency" {
		// try to unmarshal JSON data into NativeCurrency
		err = json.Unmarshal(data, &dst.NativeCurrency)
		if err == nil {
			return nil // data stored in dst.NativeCurrency, return on the first match
		} else {
			dst.NativeCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as NativeCurrency: %s", err.Error())
		}
	}

	// check if the discriminator value is 'smart_token'
	if jsonDict["type"] == "smart_token" {
		// try to unmarshal JSON data into SmartTokenCurrency
		err = json.Unmarshal(data, &dst.SmartTokenCurrency)
		if err == nil {
			return nil // data stored in dst.SmartTokenCurrency, return on the first match
		} else {
			dst.SmartTokenCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as SmartTokenCurrency: %s", err.Error())
		}
	}

	// check if the discriminator value is 'smart_token_currency'
	if jsonDict["type"] == "smart_token_currency" {
		// try to unmarshal JSON data into SmartTokenCurrency
		err = json.Unmarshal(data, &dst.SmartTokenCurrency)
		if err == nil {
			return nil // data stored in dst.SmartTokenCurrency, return on the first match
		} else {
			dst.SmartTokenCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as SmartTokenCurrency: %s", err.Error())
		}
	}

	// check if the discriminator value is 'token'
	if jsonDict["type"] == "token" {
		// try to unmarshal JSON data into TokenCurrency
		err = json.Unmarshal(data, &dst.TokenCurrency)
		if err == nil {
			return nil // data stored in dst.TokenCurrency, return on the first match
		} else {
			dst.TokenCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as TokenCurrency: %s", err.Error())
		}
	}

	// check if the discriminator value is 'token_currency'
	if jsonDict["type"] == "token_currency" {
		// try to unmarshal JSON data into TokenCurrency
		err = json.Unmarshal(data, &dst.TokenCurrency)
		if err == nil {
			return nil // data stored in dst.TokenCurrency, return on the first match
		} else {
			dst.TokenCurrency = nil
			return fmt.Errorf("Failed to unmarshal Currency as TokenCurrency: %s", err.Error())
		}
	}

	return nil
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src Currency) MarshalJSON() ([]byte, error) {
	if src.NativeCurrency != nil {
		return json.Marshal(&src.NativeCurrency)
	}

	if src.SmartTokenCurrency != nil {
		return json.Marshal(&src.SmartTokenCurrency)
	}

	if src.TokenCurrency != nil {
		return json.Marshal(&src.TokenCurrency)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *Currency) GetActualInstance() interface{} {
	if obj.NativeCurrency != nil {
		return obj.NativeCurrency
	}

	if obj.SmartTokenCurrency != nil {
		return obj.SmartTokenCurrency
	}

	if obj.TokenCurrency != nil {
		return obj.TokenCurrency
	}

	// all schemas are nil
	return nil
}

type NullableCurrency struct {
	value *Currency
	isSet bool
}

func (v NullableCurrency) Get() *Currency {
	return v.value
}

func (v *NullableCurrency) Set(val *Currency) {
	v.value = val
	v.isSet = true
}

func (v NullableCurrency) IsSet() bool {
	return v.isSet
}

func (v *NullableCurrency) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCurrency(val *Currency) *NullableCurrency {
	return &NullableCurrency{value: val, isSet: true}
}

func (v NullableCurrency) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCurrency) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
